package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsDiscountPkStockCodeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsDiscountPkStockCodeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdIsNull() {
            addCriterion("discount_pk_stock_batch_id is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdIsNotNull() {
            addCriterion("discount_pk_stock_batch_id is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdEqualTo(Long value) {
            addCriterion("discount_pk_stock_batch_id =", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdNotEqualTo(Long value) {
            addCriterion("discount_pk_stock_batch_id <>", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdGreaterThan(Long value) {
            addCriterion("discount_pk_stock_batch_id >", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdGreaterThanOrEqualTo(Long value) {
            addCriterion("discount_pk_stock_batch_id >=", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdLessThan(Long value) {
            addCriterion("discount_pk_stock_batch_id <", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdLessThanOrEqualTo(Long value) {
            addCriterion("discount_pk_stock_batch_id <=", value, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdIn(List<Long> values) {
            addCriterion("discount_pk_stock_batch_id in", values, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdNotIn(List<Long> values) {
            addCriterion("discount_pk_stock_batch_id not in", values, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdBetween(Long value1, Long value2) {
            addCriterion("discount_pk_stock_batch_id between", value1, value2, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchIdNotBetween(Long value1, Long value2) {
            addCriterion("discount_pk_stock_batch_id not between", value1, value2, "discountPkStockBatchId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoIsNull() {
            addCriterion("discount_pk_stock_batch_no is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoIsNotNull() {
            addCriterion("discount_pk_stock_batch_no is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoEqualTo(String value) {
            addCriterion("discount_pk_stock_batch_no =", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoNotEqualTo(String value) {
            addCriterion("discount_pk_stock_batch_no <>", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoGreaterThan(String value) {
            addCriterion("discount_pk_stock_batch_no >", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoGreaterThanOrEqualTo(String value) {
            addCriterion("discount_pk_stock_batch_no >=", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoLessThan(String value) {
            addCriterion("discount_pk_stock_batch_no <", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoLessThanOrEqualTo(String value) {
            addCriterion("discount_pk_stock_batch_no <=", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoLike(String value) {
            addCriterion("discount_pk_stock_batch_no like", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoNotLike(String value) {
            addCriterion("discount_pk_stock_batch_no not like", value, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoIn(List<String> values) {
            addCriterion("discount_pk_stock_batch_no in", values, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoNotIn(List<String> values) {
            addCriterion("discount_pk_stock_batch_no not in", values, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoBetween(String value1, String value2) {
            addCriterion("discount_pk_stock_batch_no between", value1, value2, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkStockBatchNoNotBetween(String value1, String value2) {
            addCriterion("discount_pk_stock_batch_no not between", value1, value2, "discountPkStockBatchNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIsNull() {
            addCriterion("discount_pk_id is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIsNotNull() {
            addCriterion("discount_pk_id is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdEqualTo(Long value) {
            addCriterion("discount_pk_id =", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotEqualTo(Long value) {
            addCriterion("discount_pk_id <>", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdGreaterThan(Long value) {
            addCriterion("discount_pk_id >", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdGreaterThanOrEqualTo(Long value) {
            addCriterion("discount_pk_id >=", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdLessThan(Long value) {
            addCriterion("discount_pk_id <", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdLessThanOrEqualTo(Long value) {
            addCriterion("discount_pk_id <=", value, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdIn(List<Long> values) {
            addCriterion("discount_pk_id in", values, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotIn(List<Long> values) {
            addCriterion("discount_pk_id not in", values, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdBetween(Long value1, Long value2) {
            addCriterion("discount_pk_id between", value1, value2, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkIdNotBetween(Long value1, Long value2) {
            addCriterion("discount_pk_id not between", value1, value2, "discountPkId");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIsNull() {
            addCriterion("discount_pk_no is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIsNotNull() {
            addCriterion("discount_pk_no is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoEqualTo(String value) {
            addCriterion("discount_pk_no =", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotEqualTo(String value) {
            addCriterion("discount_pk_no <>", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoGreaterThan(String value) {
            addCriterion("discount_pk_no >", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoGreaterThanOrEqualTo(String value) {
            addCriterion("discount_pk_no >=", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLessThan(String value) {
            addCriterion("discount_pk_no <", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLessThanOrEqualTo(String value) {
            addCriterion("discount_pk_no <=", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoLike(String value) {
            addCriterion("discount_pk_no like", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotLike(String value) {
            addCriterion("discount_pk_no not like", value, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoIn(List<String> values) {
            addCriterion("discount_pk_no in", values, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotIn(List<String> values) {
            addCriterion("discount_pk_no not in", values, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoBetween(String value1, String value2) {
            addCriterion("discount_pk_no between", value1, value2, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNoNotBetween(String value1, String value2) {
            addCriterion("discount_pk_no not between", value1, value2, "discountPkNo");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIsNull() {
            addCriterion("discount_pk_name is null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIsNotNull() {
            addCriterion("discount_pk_name is not null");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameEqualTo(String value) {
            addCriterion("discount_pk_name =", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotEqualTo(String value) {
            addCriterion("discount_pk_name <>", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameGreaterThan(String value) {
            addCriterion("discount_pk_name >", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameGreaterThanOrEqualTo(String value) {
            addCriterion("discount_pk_name >=", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLessThan(String value) {
            addCriterion("discount_pk_name <", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLessThanOrEqualTo(String value) {
            addCriterion("discount_pk_name <=", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameLike(String value) {
            addCriterion("discount_pk_name like", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotLike(String value) {
            addCriterion("discount_pk_name not like", value, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameIn(List<String> values) {
            addCriterion("discount_pk_name in", values, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotIn(List<String> values) {
            addCriterion("discount_pk_name not in", values, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameBetween(String value1, String value2) {
            addCriterion("discount_pk_name between", value1, value2, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andDiscountPkNameNotBetween(String value1, String value2) {
            addCriterion("discount_pk_name not between", value1, value2, "discountPkName");
            return (Criteria) this;
        }

        public Criteria andObtainTypeIsNull() {
            addCriterion("obtain_type is null");
            return (Criteria) this;
        }

        public Criteria andObtainTypeIsNotNull() {
            addCriterion("obtain_type is not null");
            return (Criteria) this;
        }

        public Criteria andObtainTypeEqualTo(Integer value) {
            addCriterion("obtain_type =", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeNotEqualTo(Integer value) {
            addCriterion("obtain_type <>", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeGreaterThan(Integer value) {
            addCriterion("obtain_type >", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("obtain_type >=", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeLessThan(Integer value) {
            addCriterion("obtain_type <", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeLessThanOrEqualTo(Integer value) {
            addCriterion("obtain_type <=", value, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeIn(List<Integer> values) {
            addCriterion("obtain_type in", values, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeNotIn(List<Integer> values) {
            addCriterion("obtain_type not in", values, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeBetween(Integer value1, Integer value2) {
            addCriterion("obtain_type between", value1, value2, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("obtain_type not between", value1, value2, "obtainType");
            return (Criteria) this;
        }

        public Criteria andObtainTimeIsNull() {
            addCriterion("obtain_time is null");
            return (Criteria) this;
        }

        public Criteria andObtainTimeIsNotNull() {
            addCriterion("obtain_time is not null");
            return (Criteria) this;
        }

        public Criteria andObtainTimeEqualTo(Date value) {
            addCriterion("obtain_time =", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeNotEqualTo(Date value) {
            addCriterion("obtain_time <>", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeGreaterThan(Date value) {
            addCriterion("obtain_time >", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("obtain_time >=", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeLessThan(Date value) {
            addCriterion("obtain_time <", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeLessThanOrEqualTo(Date value) {
            addCriterion("obtain_time <=", value, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeIn(List<Date> values) {
            addCriterion("obtain_time in", values, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeNotIn(List<Date> values) {
            addCriterion("obtain_time not in", values, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeBetween(Date value1, Date value2) {
            addCriterion("obtain_time between", value1, value2, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andObtainTimeNotBetween(Date value1, Date value2) {
            addCriterion("obtain_time not between", value1, value2, "obtainTime");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdIsNull() {
            addCriterion("receive_mer_user_id is null");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdIsNotNull() {
            addCriterion("receive_mer_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdEqualTo(Long value) {
            addCriterion("receive_mer_user_id =", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdNotEqualTo(Long value) {
            addCriterion("receive_mer_user_id <>", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdGreaterThan(Long value) {
            addCriterion("receive_mer_user_id >", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("receive_mer_user_id >=", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdLessThan(Long value) {
            addCriterion("receive_mer_user_id <", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdLessThanOrEqualTo(Long value) {
            addCriterion("receive_mer_user_id <=", value, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdIn(List<Long> values) {
            addCriterion("receive_mer_user_id in", values, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdNotIn(List<Long> values) {
            addCriterion("receive_mer_user_id not in", values, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdBetween(Long value1, Long value2) {
            addCriterion("receive_mer_user_id between", value1, value2, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserIdNotBetween(Long value1, Long value2) {
            addCriterion("receive_mer_user_id not between", value1, value2, "receiveMerUserId");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneIsNull() {
            addCriterion("receive_mer_user_phone is null");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneIsNotNull() {
            addCriterion("receive_mer_user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneEqualTo(String value) {
            addCriterion("receive_mer_user_phone =", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneNotEqualTo(String value) {
            addCriterion("receive_mer_user_phone <>", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneGreaterThan(String value) {
            addCriterion("receive_mer_user_phone >", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("receive_mer_user_phone >=", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneLessThan(String value) {
            addCriterion("receive_mer_user_phone <", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("receive_mer_user_phone <=", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneLike(String value) {
            addCriterion("receive_mer_user_phone like", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneNotLike(String value) {
            addCriterion("receive_mer_user_phone not like", value, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneIn(List<String> values) {
            addCriterion("receive_mer_user_phone in", values, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneNotIn(List<String> values) {
            addCriterion("receive_mer_user_phone not in", values, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneBetween(String value1, String value2) {
            addCriterion("receive_mer_user_phone between", value1, value2, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andReceiveMerUserPhoneNotBetween(String value1, String value2) {
            addCriterion("receive_mer_user_phone not between", value1, value2, "receiveMerUserPhone");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIsNull() {
            addCriterion("agent_appid is null");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIsNotNull() {
            addCriterion("agent_appid is not null");
            return (Criteria) this;
        }

        public Criteria andAgentAppidEqualTo(String value) {
            addCriterion("agent_appid =", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotEqualTo(String value) {
            addCriterion("agent_appid <>", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidGreaterThan(String value) {
            addCriterion("agent_appid >", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidGreaterThanOrEqualTo(String value) {
            addCriterion("agent_appid >=", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLessThan(String value) {
            addCriterion("agent_appid <", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLessThanOrEqualTo(String value) {
            addCriterion("agent_appid <=", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidLike(String value) {
            addCriterion("agent_appid like", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotLike(String value) {
            addCriterion("agent_appid not like", value, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidIn(List<String> values) {
            addCriterion("agent_appid in", values, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotIn(List<String> values) {
            addCriterion("agent_appid not in", values, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidBetween(String value1, String value2) {
            addCriterion("agent_appid between", value1, value2, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andAgentAppidNotBetween(String value1, String value2) {
            addCriterion("agent_appid not between", value1, value2, "agentAppid");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}